// Auto-generated. Do not edit!

// (in-package ros_google_cloud_language.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let TextEntity = require('./TextEntity.js');
let TextSyntax = require('./TextSyntax.js');

//-----------------------------------------------------------

class AnalyzeTextResult {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.entities = null;
      this.syntaxes = null;
      this.sentiment_score = null;
      this.sentiment_magnitude = null;
    }
    else {
      if (initObj.hasOwnProperty('entities')) {
        this.entities = initObj.entities
      }
      else {
        this.entities = [];
      }
      if (initObj.hasOwnProperty('syntaxes')) {
        this.syntaxes = initObj.syntaxes
      }
      else {
        this.syntaxes = [];
      }
      if (initObj.hasOwnProperty('sentiment_score')) {
        this.sentiment_score = initObj.sentiment_score
      }
      else {
        this.sentiment_score = 0.0;
      }
      if (initObj.hasOwnProperty('sentiment_magnitude')) {
        this.sentiment_magnitude = initObj.sentiment_magnitude
      }
      else {
        this.sentiment_magnitude = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type AnalyzeTextResult
    // Serialize message field [entities]
    // Serialize the length for message field [entities]
    bufferOffset = _serializer.uint32(obj.entities.length, buffer, bufferOffset);
    obj.entities.forEach((val) => {
      bufferOffset = TextEntity.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [syntaxes]
    // Serialize the length for message field [syntaxes]
    bufferOffset = _serializer.uint32(obj.syntaxes.length, buffer, bufferOffset);
    obj.syntaxes.forEach((val) => {
      bufferOffset = TextSyntax.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [sentiment_score]
    bufferOffset = _serializer.float32(obj.sentiment_score, buffer, bufferOffset);
    // Serialize message field [sentiment_magnitude]
    bufferOffset = _serializer.float32(obj.sentiment_magnitude, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type AnalyzeTextResult
    let len;
    let data = new AnalyzeTextResult(null);
    // Deserialize message field [entities]
    // Deserialize array length for message field [entities]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.entities = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.entities[i] = TextEntity.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [syntaxes]
    // Deserialize array length for message field [syntaxes]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.syntaxes = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.syntaxes[i] = TextSyntax.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [sentiment_score]
    data.sentiment_score = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [sentiment_magnitude]
    data.sentiment_magnitude = _deserializer.float32(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.entities.forEach((val) => {
      length += TextEntity.getMessageSize(val);
    });
    object.syntaxes.forEach((val) => {
      length += TextSyntax.getMessageSize(val);
    });
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'ros_google_cloud_language/AnalyzeTextResult';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'b9d5e0e891db431f1002d8672ecfbcae';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # Define the result
    ros_google_cloud_language/TextEntity[] entities
    ros_google_cloud_language/TextSyntax[] syntaxes
    float32 sentiment_score
    float32 sentiment_magnitude
    
    ================================================================================
    MSG: ros_google_cloud_language/TextEntity
    # ROS interface for https://googleapis.dev/python/language/latest/language_v1/types.html#google.cloud.language_v1.types.Entity
    
    string name
    int32 type
    
    # Enumerate of entity type
    # https://googleapis.dev/python/language/latest/language_v1/types.html#google.cloud.language_v1.types.Entity.Type
    uint8 ADDRESS = 10
    uint8 CONSUMER_GOOD = 6
    uint8 DATE = 11
    uint8 EVENT = 4
    uint8 LOCATION = 2
    uint8 NUMBER = 12
    uint8 ORGANIZATION = 3
    uint8 OTHER = 7
    uint8 PERSON = 1
    uint8 PHONE_NUMBER = 9
    uint8 PRICE = 13
    uint8 UNKNOWN = 0
    uint8 WORK_OF_ART = 5
    
    diagnostic_msgs/KeyValue[] metadata
    float32 salience
    
    ================================================================================
    MSG: diagnostic_msgs/KeyValue
    string key # what to label this value when viewing
    string value # a value to track over time
    
    ================================================================================
    MSG: ros_google_cloud_language/TextSyntax
    # correspond to demo syntax result in https://cloud.google.com/natural-language
    string name
    string lemma
    int32 dependency_edge
    int32 part_of_speech
    int32 parse_label
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new AnalyzeTextResult(null);
    if (msg.entities !== undefined) {
      resolved.entities = new Array(msg.entities.length);
      for (let i = 0; i < resolved.entities.length; ++i) {
        resolved.entities[i] = TextEntity.Resolve(msg.entities[i]);
      }
    }
    else {
      resolved.entities = []
    }

    if (msg.syntaxes !== undefined) {
      resolved.syntaxes = new Array(msg.syntaxes.length);
      for (let i = 0; i < resolved.syntaxes.length; ++i) {
        resolved.syntaxes[i] = TextSyntax.Resolve(msg.syntaxes[i]);
      }
    }
    else {
      resolved.syntaxes = []
    }

    if (msg.sentiment_score !== undefined) {
      resolved.sentiment_score = msg.sentiment_score;
    }
    else {
      resolved.sentiment_score = 0.0
    }

    if (msg.sentiment_magnitude !== undefined) {
      resolved.sentiment_magnitude = msg.sentiment_magnitude;
    }
    else {
      resolved.sentiment_magnitude = 0.0
    }

    return resolved;
    }
};

module.exports = AnalyzeTextResult;
